unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,NNNetworkLibrary, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Edit1: TEdit;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    N3L:TNNNetworkSession;
    Connected:Boolean;
    Online:Array[0..7] of Boolean;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
    N3L:=TNNNetworkSession.Create;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    N3L.LeaveSession;
    N3L.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
var   i:integer;
    str:String;
    ptr:Pointer;
    sz:Integer;
begin
    if not Connected then begin
        N3L.JoinSession(Edit1.Text);
        Timer1.Enabled:=True;
        Button1.Enabled:=False;
        Button1.Caption:='ڑ';
    end else begin
        for i:=0 to 7 do begin
            if N3L.Online(i) then begin
                str:=Edit1.Text;
                sz:=Pack(ptr,'t',[@str]);
                N3L.SetBlock(i,0,ptr,sz);
                FreeMem(ptr,sz);
            end;
        end;
    end;
    Edit1.Text:='';
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var lcr:String;
    i:integer;
    com:Integer;
    str:String;
    ptr:Pointer;
begin
    if not Connected then begin
        //ؒfRXVĂ玸s
        lcr:=N3L.LastCloseReason;
        if lcr<>'' then begin
            Button1.Caption:='s';
            Memo1.Lines.Add(lcr);
            Memo1.Lines.Add('ċNĂ');
            Timer1.Enabled:=False;
            exit;
        end;
        //T[o[0ԂICȂIC
        if N3L.Online(0) then begin
            Button1.Caption:='';
            Button1.Enabled:=True;
            Connected:=True;
        end;
    end else begin
        for i:=0 to 7 do begin
            if N3L.BlockCount(i)>0 then begin
                ptr:=N3L.GetBlock(i,com);
                UnPack(ptr,'t',[@str]);
                Memo1.Lines.Add(str);
                FreeMem(ptr);
            end;
        end;
    end;
end;

end.
