unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,NNNetworkLibrary, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    N3L:TNNNetworkSession;
    SayCount:Array[0..7] of Integer;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
    N3L:=TNNNetworkSession.Create;
    N3L.OpenSession(8);
    Timer1.Enabled:=True;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    Timer1.Enabled:=False;
    N3L.CloseSession;
    N3L.Free;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var i:integer;
    comp:TComponent;
    bc:Integer;
    j:integer;
    vcom:Integer;
begin
    For i:=0 to 7 do begin
        comp:=FindComponent('Label'+IntToStr(i+1));
        if N3L.Online(i) then begin
            bc:=N3L.BlockCount(i);
            if bc>0 then begin
                SayCount[i]:=SayCount[i]+bc;
                For j:=0 to bc-1 do begin
                    FreeMem(N3L.GetBlock(i,vcom));
                end;
            end;
            TLabel(comp).Caption:='OnLine '+IntToStr(SayCount[i]);
        end else begin
            TLabel(comp).Caption:='OffLine';
            SayCount[i]:=0;
        end;
    end;
end;

end.
